#pragma once

#include "Color.h"

#include <wrl.h>

class SceneModel;
class Point;
class DirectX2dInterface;

struct ID2D1SolidColorBrush;

namespace D2D1
{
	class ColorF;
}
struct D2D_POINT_2F;

class DirectX2dPainter
{
public:
	void startDrawing();

	void clearBackground(const Color& color);

	void finishDrawing();

	void paint(SceneModel* model);

	void setD2dInterface(DirectX2dInterface* d2dIterface);

private:
	static D2D1::ColorF toD2dColor(const Color& color);

	static D2D_POINT_2F toD2dPoint(const Point& point);

	void paintRect(SceneModel* model);

	void paintCircle(SceneModel* model);

	void paintPath(SceneModel* model);

	Microsoft::WRL::ComPtr<ID2D1SolidColorBrush> mSolidBrush;
	
	DirectX2dInterface* mD2dInterface{ nullptr };
};