#pragma once

#include "AbstractVisualNode.h"

#include "Color.h"

class MaterialNode : public AbstractVisualNode
{
public:
    MaterialNode(const Point& location);

    const Color& getFillColor() const;
    const Color& getStrokeColor() const;

    void setHasStrokeColor(bool hasStroke);
    void setHasFillColor(bool hasFill);

    void setFillColor(const Color& color);
    void setStrokeColor(const Color& color);

protected:
    bool mHasFillColor{ false };
    bool mHasStrokeColor{ true };

    Color mFillColor;
    Color mStrokeColor;
    bool mMaterialIsDirty{true};
};
