#pragma once

#include "MaterialNode.h"
#include "GeometryNode.h"
#include "SvgDocument.h"

#include <memory>
#include <vector>

class SvgNode : public MaterialNode
{
public:
    SvgNode(const Point& location);

    void setContent(std::unique_ptr<SvgDocument> doc);

    void setWidth(unsigned width);
    void setHeight(unsigned height);

    void update(SceneInfo* sceneInfo);
private:
    void createOrUpdateGeometry(SceneInfo* sceneInfo);
    void updateTransform();

    void onCircle(XmlElement* element, std::unique_ptr<GeometryNode>& node);
    void onPath(XmlElement* element, std::unique_ptr<GeometryNode>& node);

    unsigned mWidth{ 0 };
    unsigned mHeight{ 0 };

    bool mContentDirty{ true };

    std::vector<std::unique_ptr<GeometryNode> > mGeometryNodes;
    std::unique_ptr<SvgDocument> mContent;
};
